--------------------------------------------------------------------------
-- SlaveGirl.lua 
--------------------------------------------------------------------------
--[[
Slave Girl
Author: Zensunim of Malygos

Change Log:
	v1.0 
		- Initial Release
	v1.1
		- Updated sounds to play on the Master channel instead of the SFX channel
	v1.1.1
		- Updated TOC for 4.1
	v1.1.2
		- Updated TOC for 4.2
	v1.1.3
		- Fixed bug with following a character
	v1.1.4
		- Updated TOC for 4.3
	v1.1.5
		- Updated for 5.0.4

Configuration Commands:
	/SG options - Display the options menu
	/SG master - Follow orders from this player

]]--

if (SlaveGirl) then
	-- Do nothing
else
	SlaveGirl = { };
end

SlaveGirlOptions = { };

SlaveGirl = {
	DefaultSetting = {
		LowHealthThreshold = 50;
		LowHealthCooldown = 15;
		LowManaThreshold = 40;
		LowManaCooldown = 25;
		Monitor = true;
		Broadcast = nil;
		StartFollowSound = true;
		StopFollowSound = true;
		LowHealthSound = true;
		LowManaSound = true;
		AutoAcceptGroupInvite = true;
		AutoAcceptQuest = true;
		AutoShareQuest = true;
		AutoTurnInQuest = nil;
		Master = nil;
	};

-- **********************************************************************************************
--
-- DON'T EDIT BELOW THIS LINE
--
-- **********************************************************************************************

	Version = "1.1.5"; -- Version number (text format)
	DataCode = "1"; -- Saved Variable versioning, change this value to force a reset to default
	ModCode = "KSG"; -- Mod communication code
	Setting = { };

	Data = {
		SilentFollow = nil;
		TimerPowerInfusion = 0;
		TimerLowHealth = GetTime();
		TimerLowMana = GetTime();
		Me = UnitName("player");
		InGroup = (GetNumGroupMembers() > 0);
		SlaveInGroup = nil;
		MasterInGroup = nil;
		Slaves = { };
		LowHealthThreshold = 0;
		LowManaThreshold = 0;
	};
	
	Sounds = {
		["StartFollow"] = "Interface\\AddOns\\SlaveGirl\\Sounds\\follow_on.ogg",
		["StopFollow"] = "Interface\\AddOns\\SlaveGirl\\Sounds\\follow_off.ogg",
		["LowMana"] = "Interface\\AddOns\\SlaveGirl\\Sounds\\low_mana.mp3",
		["LowHealth"] = "Interface\\AddOns\\SlaveGirl\\Sounds\\low_health.ogg",
	};	
}

function SlaveGirl_ResetDefaults()
	SlaveGirl.Setting.LowHealthThreshold = SlaveGirl.DefaultSetting.LowHealthThreshold;
	SlaveGirl.Setting.LowHealthCooldown = SlaveGirl.DefaultSetting.LowHealthCooldown;
	SlaveGirl.Setting.LowManaThreshold = SlaveGirl.DefaultSetting.LowManaThreshold;
	SlaveGirl.Setting.LowManaCooldown = SlaveGirl.DefaultSetting.LowManaCooldown;
	SlaveGirl.Setting.Monitor = SlaveGirl.DefaultSetting.Monitor;
	SlaveGirl.Setting.Broadcast = SlaveGirl.DefaultSetting.Broadcast;
	SlaveGirl.Setting.StartFollowSound = SlaveGirl.DefaultSetting.StartFollowSound;
	SlaveGirl.Setting.StopFollowSound = SlaveGirl.DefaultSetting.StopFollowSound;
	SlaveGirl.Setting.LowHealthSound = SlaveGirl.DefaultSetting.LowHealthSound;
	SlaveGirl.Setting.LowManaSound = SlaveGirl.DefaultSetting.LowManaSound;
	SlaveGirl.Setting.AutoAcceptGroupInvite = SlaveGirl.DefaultSetting.AutoAcceptGroupInvite;
	SlaveGirl.Setting.AutoAcceptQuest = SlaveGirl.DefaultSetting.AutoAcceptQuest;
	SlaveGirl.Setting.AutoShareQuest = SlaveGirl.DefaultSetting.AutoShareQuest;
	SlaveGirl.Setting.AutoTurnInQuest = SlaveGirl.DefaultSetting.AutoTurnInQuest;
	SlaveGirl.Setting.Master = SlaveGirl.DefaultSetting.Master;
end

SlaveGirl_ResetDefaults();

function SlaveGirl_OnEvent(self, event, ...)
	if (event == "VARIABLES_LOADED") then
		RegisterAddonMessagePrefix(SlaveGirl.ModCode);
		SlaveGirl_DebugPrint("Slave Girl "..SlaveGirl.Version.." variables loaded.");
		SlaveGirlTooltip:SetOwner(UIParent, "ANCHOR_NONE");
		SlaveGirlFrame:RegisterEvent("START_AUTOREPEAT_SPELL");
		SlaveGirlFrame:RegisterEvent("STOP_AUTOREPEAT_SPELL");
		SlaveGirlFrame:RegisterEvent("UI_ERROR_MESSAGE");
		SlaveGirlFrame:RegisterEvent("AUTOFOLLOW_BEGIN");
		SlaveGirlFrame:RegisterEvent("AUTOFOLLOW_END");
		SlaveGirlFrame:RegisterEvent("PARTY_INVITE_REQUEST");
		SlaveGirlFrame:RegisterEvent("PARTY_MEMBERS_CHANGED");
		SlaveGirlFrame:RegisterEvent("QUEST_DETAIL");
		SlaveGirlFrame:RegisterEvent("QUEST_ACCEPTED");
		SlaveGirlFrame:RegisterEvent("QUEST_PROGRESS");
		SlaveGirlFrame:RegisterEvent("QUEST_COMPLETE");
		SlaveGirlFrame:RegisterEvent("CHAT_MSG_ADDON");
		SlaveGirlFrame:RegisterEvent("PLAYER_TARGET_CHANGED");

		if (SlaveGirlOptions.DataCode ~= SlaveGirl.DataCode or not (SlaveGirlOptions.Setting)) then
			SlaveGirlOptions = { };
			SlaveGirlOptions.DataCode = SlaveGirl.DataCode;
			SlaveGirlOptions.Setting = { };
			SlaveGirl_ErrorPrint("New database detected. Clearing settings.");
		elseif (SlaveGirlOptions.Setting[SlaveGirl.Data.Me]) then
			SlaveGirl_DebugPrint("Profile found. Loading settings");
			if (SlaveGirlOptions.Setting[SlaveGirl.Data.Me].LowHealthThreshold) then
				SlaveGirl.Setting.LowHealthThreshold = SlaveGirlOptions.Setting[SlaveGirl.Data.Me].LowHealthThreshold;
			end
			if (SlaveGirlOptions.Setting[SlaveGirl.Data.Me].LowHealthCooldown) then
				SlaveGirl.Setting.LowHealthCooldown = SlaveGirlOptions.Setting[SlaveGirl.Data.Me].LowHealthCooldown;
			end
			if (SlaveGirlOptions.Setting[SlaveGirl.Data.Me].LowManaThreshold) then
				SlaveGirl.Setting.LowManaThreshold = SlaveGirlOptions.Setting[SlaveGirl.Data.Me].LowManaThreshold;
			end
			if (SlaveGirlOptions.Setting[SlaveGirl.Data.Me].LowManaCooldown) then
				SlaveGirl.Setting.LowManaCooldown = SlaveGirlOptions.Setting[SlaveGirl.Data.Me].LowManaCooldown;
			end
			SlaveGirl.Setting.Monitor = SlaveGirlOptions.Setting[SlaveGirl.Data.Me].Monitor;
			SlaveGirl.Setting.Broadcast = SlaveGirlOptions.Setting[SlaveGirl.Data.Me].Broadcast;
			SlaveGirl.Setting.StartFollowSound = SlaveGirlOptions.Setting[SlaveGirl.Data.Me].StartFollowSound;
			SlaveGirl.Setting.StopFollowSound = SlaveGirlOptions.Setting[SlaveGirl.Data.Me].StopFollowSound;
			SlaveGirl.Setting.LowHealthSound = SlaveGirlOptions.Setting[SlaveGirl.Data.Me].LowHealthSound;
			SlaveGirl.Setting.LowManaSound = SlaveGirlOptions.Setting[SlaveGirl.Data.Me].LowManaSound;
			SlaveGirl.Setting.AutoAcceptGroupInvite = SlaveGirlOptions.Setting[SlaveGirl.Data.Me].AutoAcceptGroupInvite;
			SlaveGirl.Setting.AutoAcceptQuest = SlaveGirlOptions.Setting[SlaveGirl.Data.Me].AutoAcceptQuest;
			SlaveGirl.Setting.AutoShareQuest = SlaveGirlOptions.Setting[SlaveGirl.Data.Me].AutoShareQuest;
			SlaveGirl.Setting.AutoTurnInQuest = SlaveGirlOptions.Setting[SlaveGirl.Data.Me].AutoTurnInQuest;
			SlaveGirl.Setting.Master = SlaveGirlOptions.Setting[SlaveGirl.Data.Me].Master;
		else
			SlaveGirl_ErrorPrint("New player detected. Setting defaults.");
		end
		
		SlaveGirl_CheckGroup(true);
		SlaveGirl_RenderOptions();
		SlaveGirl_SaveSettings();
		return;
	end
	if (event == "AUTOFOLLOW_BEGIN") then
		local follower = ...;
		SlaveGirl.Data.SilentFollow = nil;
		if (follower) then
			SlaveGirl_SendComm("F/S/"..follower);
		else
			SlaveGirl_SendComm("F/S");
		end
		if (SlaveGirl.Setting.StartFollowSound) then
			SlaveGirl_PlaySound("StartFollow");
		end
		return;
	end
	if (event == "AUTOFOLLOW_END") then
		if not (SlaveGirl.Data.SilentFollow) then
			if (SlaveGirl.Setting.StopFollowSound) then
				SlaveGirl_PlaySound("StopFollow");
			end
			SlaveGirl_SendComm("F/X");
			return;
		end
	end		
	if (event == "PARTY_INVITE_REQUEST") then
		local partyMaster = ...;
		if (SlaveGirl.Setting.AutoAcceptGroupInvite and SlaveGirl.Setting.Master) then
			if (SlaveGirl.Setting.Master == partyMaster) then
				AcceptGroup();
			end
		end
		return;
	end
	if (event == "PARTY_MEMBERS_CHANGED") then
		if (SlaveGirl.Setting.AutoAcceptGroupInvite and SlaveGirl.Setting.Master) then
			StaticPopupDialogs["PARTY_INVITE"].inviteAccepted = 1;
			StaticPopup_Hide("PARTY_INVITE");
		end
		if not (SlaveGirl.Data.InGroup) then
			SlaveGirl_CheckGroup(true);
		end
		SlaveGirl.Data.InGroup = (GetNumSubgroupMembers() > 0)
		if (SlaveGirl.Data.InGroup) then
			SlaveGirl_CheckGroup(false);
		end
		return;
	end
	if (event == "QUEST_DETAIL") then
		if (SlaveGirl.Setting.AutoAcceptQuest and SlaveGirl.Setting.Master) then
			if (UnitName("player") == UnitName("NPC")) then
				SlaveGirl_DebugPrint("Auto-Accepting quest.");
				SlaveGirl_SendComm("O/Q/"..GetTitleText());
				AcceptQuest();
				HideUIPanel(QuestFrame);
			end
		end
		return;
	end
	if (event == "QUEST_ACCEPTED") then
		local index = ...;
		if (SlaveGirl.Setting.AutoShareQuest and (SlaveGirl.Data.SlaveInGroup or SlaveGirl.Data.MasterInGroup)) then
			SlaveGirl_ShareQuest(index);
		end
		if (SlaveGirl.Setting.AutoTurnInQuest) then
			if (QuestGetAutoAccept()) then
				HideUIPanel(QuestFrame);
			end
		end
    return;
	end
	if (event == "QUEST_PROGRESS") then
		if (SlaveGirl.Setting.AutoTurnInQuest) then
			SlaveGirl_DebugPrint("Quest progress");
			if (IsQuestCompletable()) then
				CompleteQuest();
			end
		end
    return;
	end
	if (event == "QUEST_COMPLETE") then
		if (SlaveGirl.Setting.AutoTurnInQuest) then
			SlaveGirl_DebugPrint("Quest choices: "..GetNumQuestChoices());
			if (GetNumQuestChoices() < 2) then
			    GetQuestReward();
			    HideUIPanel(QuestFrame);
			end
		end
    return;
	end
	if (event == "CHAT_MSG_ADDON") then
		local prefix, message, messageType, sender = ...;
		if ( sender ~= SlaveGirl.Data.Me ) then
			if ( prefix == SlaveGirl.ModCode) then
				SlaveGirl_ReceiveComm(message, sender);
			end
		end
		return;
	end
	if (event == "UI_ERROR_MESSAGE") then
		local message = ...;
		if ( message == ERR_SPELL_COOLDOWN ) then
			SlaveGirl_SendComm("E/C");
			return;
		end
		if ( message == ERR_SPELL_OUT_OF_RANGE ) then
			SlaveGirl_SendComm("E/R");
			return;
		end
		if ( message == SPELL_FAILED_MOVING ) then
			SlaveGirl_SendComm("E/V");
			return;
		end
		if ( message == SPELL_FAILED_LINE_OF_SIGHT ) then
			SlaveGirl_SendComm("E/L");
			return;
		end
		if ( message == SPELL_FAILED_BAD_TARGETS ) then
			SlaveGirl_SendComm("E/B");
			return;
		end
		if ( message == ERR_OUT_OF_MANA ) then
			SlaveGirl_SendComm("E/M");
			return;
		end
		if ( message == SPELL_FAILED_UNIT_NOT_INFRONT ) then
			SlaveGirl_SendComm("E/F");
			return;
		end
		if ( message == SPELL_FAILED_SILENCED ) or ( message == SPELL_FAILED_STUNNED ) then
			SlaveGirl_SendComm("E/S");
			return;
		end
		if ( message == ERR_ATTACK_PACIFIED ) or ( message == ERR_ATTACK_CHARMED ) then
			SlaveGirl_SendComm("E/S");
			return;
		end
		if ( message == ERR_ATTACK_CONFUSED ) or ( message == ERR_ATTACK_FLEEING ) then
			SlaveGirl_SendComm("E/S");
			return;
		end
		if ( message == ERR_ATTACK_PREVENTED_BY_MECHANIC_S ) or ( message == "Can't attack while polymorphed." ) then
			SlaveGirl_SendComm("E/S");
			return;
		end
	end
end

function SlaveGirl_ChatPrint(str)
	DEFAULT_CHAT_FRAME:AddMessage("[SG] "..str, 0.25, 1.0, 0.25);
end

function SlaveGirl_ErrorPrint(str)
	DEFAULT_CHAT_FRAME:AddMessage("[SG] "..str, 1.0, 0.5, 0.5);
end

function SlaveGirl_DebugPrint(str)
	--DEFAULT_CHAT_FRAME:AddMessage("[SG] "..str, 0.75, 1.0, 0.25);
end

function SlaveGirl_CommPrint(str)
	DEFAULT_CHAT_FRAME:AddMessage(str, 0.45, 0.78, 0.96);
end

function SlaveGirl_FindPattern(text, pattern)
	if (string.find(text, pattern, 1)) then
		return string.sub(text, string.find(text, pattern, 1));
	else
		return nil;
	end
end

function SlaveGirl_OnLoad()
	SlashCmdList["SG"] = SlaveGirl_Command;
	SLASH_SG1 = "/SG";
	SlashCmdList["SLAVEGIRL"] = SlaveGirl_Command;
	SLASH_SLAVEGIRL1 = "/SLAVEGIRL";
	SlaveGirlFrame:RegisterEvent("CHAT_MSG_ADDON");
	SlaveGirl_ChatPrint("Slave Girl "..SlaveGirl.Version.." loaded.");
	SlaveGirlFrame:RegisterEvent("VARIABLES_LOADED");
end

function SlaveGirl_Command(arg1)
	local Command = string.upper(arg1);
	local DescriptionOffset = string.find(arg1,"%s",1);
	local Description = nil;
	
	if (DescriptionOffset) then
		Command = string.upper(string.sub(arg1, 1, DescriptionOffset - 1));
		Description = tostring(string.sub(arg1, DescriptionOffset + 1));
	end
	
	SlaveGirl_DebugPrint("Command executed: "..Command);
	
	if (Command == "MASTER") then
		SlaveGirl_Command_Master(Description);
	elseif (Command == "MONITOR") then
		SlaveGirl_Command_Monitor();
	elseif (Command == "FOLLOW") then
		SlaveGirl_Command_Follow();
	elseif (Command == "BROADCAST") then
		SlaveGirl_Command_Broadcast();
	elseif (Command == "STATUS") then
		SlaveGirl_Command_Status();
	elseif (Command == "OPTION" or Command == "OPTIONS") then
		InterfaceOptionsFrame_OpenToCategory("Slave Girl")
	elseif (Command == "HELP" or Command == "") then
		SlaveGirl_Command_Help();
	else
		SlaveGirl_Command_Help();
	end
end

function SlaveGirl_OnUpdate()
		local currentTime = GetTime();
		if (UnitIsDeadOrGhost("player")) then
			return;
		end
		local hp = UnitHealth("player");
		if (hp > 1) then
			if (SlaveGirl.Setting.LowHealthSound and currentTime > SlaveGirl.Data.TimerLowHealth and (((hp * 100) / UnitHealthMax("player")) < SlaveGirl.Setting.LowHealthThreshold)) then
				SlaveGirl_PlaySound("LowHealth")
				SlaveGirl.Data.TimerLowHealth = GetTime() + SlaveGirl.Setting.LowHealthCooldown;
			end
			if (SlaveGirl.Setting.LowManaSound and currentTime > SlaveGirl.Data.TimerLowMana and (((UnitMana("player") * 100) / UnitManaMax("player")) < SlaveGirl.Setting.LowManaThreshold) and (UnitPowerType("player") == 0)) then
				SlaveGirl_PlaySound("LowMana");
				SlaveGirl.Data.TimerLowMana = GetTime() + SlaveGirl.Setting.LowManaCooldown;
			end
		end
end

function SlaveGirl_Command_Follow()
	SlaveGirl.Data.SilentFollow = true;
	FollowUnit("target");
end

function SlaveGirl_Command_Help()
	DEFAULT_CHAT_FRAME:AddMessage("[SG] Slave Girl "..SlaveGirl.Version, 0.25, 1.0, 0.25);
	DEFAULT_CHAT_FRAME:AddMessage("|cFFEEEE00/sg options|r -- Display options", 0.25, 1.0, 0.75);
	DEFAULT_CHAT_FRAME:AddMessage("|cFFEEEE00/sg master|r -- Set your current target as your master (or to nobody if you have no target)", 0.25, 1.0, 0.75);

end

function SlaveGirl_Command_Master(arg1)
	local sName;
	if (arg1 and arg1 ~= "") then
		if (arg1 == "c" or arg1 == "C") then
			SlaveGirl.Setting.Master = nil;
			SlaveGirl_ChatPrint("You are no longer taking orders from anyone.");
		elseif (arg1 == SlaveGirl.Data.Me) then
			SlaveGirl_ErrorPrint("You cannot be your own master.");
		else
			SlaveGirl.Setting.Master = arg1;
			SlaveGirl_ChatPrint("You are now taking orders from "..arg1..".");
			SlaveGirl_ReportToMaster(arg1);
		end
	else
		sName = UnitName("target");
		if (sName and sName == SlaveGirl.Data.Me) then
			SlaveGirl_ErrorPrint("You cannot be your own master.");
		elseif (sName and not UnitIsPlayer("target")) then
			SlaveGirl_ErrorPrint("Only players can be masters.");
		elseif (sName) then
			SlaveGirl.Setting.Master = sName;
			SlaveGirl_ChatPrint("You are now taking orders from "..sName..".");
			SlaveGirl_ReportToMaster(sName);
		else
			SlaveGirl.Setting.Master = nil;
			SlaveGirl_ChatPrint("You are no longer taking orders from anyone.");
		end
	end
	SlaveGirl_SaveSettings();
end

function SlaveGirl_PlaySound(sSound)
	PlaySoundFile(SlaveGirl.Sounds[sSound], "Master");
end

function SlaveGirl_Command_Monitor()
	if (SlaveGirl.Setting.Monitor == true) then
		SlaveGirl.Setting.Monitor = nil;
		SlaveGirl_ChatPrint("Monitoring activity is off.");
	else
		SlaveGirl.Setting.Monitor = true;
		SlaveGirl_ChatPrint("Monitoring activity is on.");
	end
		SlaveGirl_DebugPrint("Monitor loaded: "..tostring(SlaveGirl.Setting.Monitor).."/"..tostring(SlaveGirlOptions.Setting[SlaveGirl.Data.Me].Monitor));
	SlaveGirl_SaveSettings();
		SlaveGirl_DebugPrint("Monitor loaded: "..tostring(SlaveGirl.Setting.Monitor).."/"..tostring(SlaveGirlOptions.Setting[SlaveGirl.Data.Me].Monitor));
end

function SlaveGirl_Command_Broadcast()
	if (SlaveGirl.Setting.Broadcast == true) then
		SlaveGirl.Setting.Broadcast = nil;
		SlaveGirl_ChatPrint("Broadcasting activity is off.");
	else
		SlaveGirl.Setting.Broadcast = true;
		SlaveGirl_ChatPrint("Broadcasting activity is on.");
	end
	SlaveGirl_SaveSettings();
end

function SlaveGirl_SendComm(sNewMessage, bOverride)
	if (SlaveGirl.Setting.Broadcast or bOverride) then	
		if (UnitInBattleground("player")) then
			SendAddonMessage(SlaveGirl.ModCode,sNewMessage,"BATTLEGROUND");
		else		
			SendAddonMessage(SlaveGirl.ModCode,sNewMessage,"RAID");
		end
		--SlaveGirl_DebugPrint("Sending Comm: "..tostring(sNewMessage));
	end
end

function SlaveGirl_ReceiveComm(sMessage, sSender)
	local decodedMessage = SlaveGirl_CommDecode(sMessage, sSender);
	SlaveGirl_DebugPrint("Message from "..sSender..": "..sMessage);
	if (decodedMessage) then
		if (decodedMessage == "COMMAND:MASTER") then
			SlaveGirl_ReportToMaster(sSender);
		elseif (decodedMessage == "COMMAND:SLAVE") then
			SlaveGirl.Data.Slaves[sSender] = true;
			SlaveGirl_DebugPrint(sSender.." has reported in.");
			SlaveGirl_CheckGroup(false);
		else
			if (SlaveGirl.Setting.Monitor and SlaveGirl.Data.Slaves[sSender]) then
				SlaveGirl_CommPrint("[SG] ["..sSender.."]: "..decodedMessage);
			end
		end
	end
end

function SlaveGirl_CommDecode(sText, sSender)
	if (sText == "") or not (sText) then
		return nil;
	end
	
	local DecodedMessage = nil;
	local Slash = string.find(sText,"/",1);
	local Slash2 = "";
	local Slash3 = "";
	local Command = "";
	local CommandType = "";
	local Data = "";
	local Data2 = "";
	
	if (Slash) then
		CommandType = string.sub(sText,1,Slash - 1);
		Slash2 = string.find(sText,"/",Slash + 1);
		if (Slash2) then
			Command = string.sub(sText,Slash + 1,Slash2 - 1);
			Slash3 = string.find(sText,"/",Slash2 + 1);
			if (Slash3) then
				Data = string.sub(sText,Slash2 + 1,Slash3 - 1);
				Data2 = string.sub(sText,Slash3 + 1);
			else
				Data = string.sub(sText,Slash2 + 1);
			end
		else
			Command = string.sub(sText,Slash + 1)
		end
	else
		CommandType = sText;
	end
	
	if (CommandType == "X") then
		if (Command == "W") then
			DecodedMessage = "Wand: (Stop)";
		elseif (Command == "H") then
			DecodedMessage = "Heal: Aborted: "..Data;
		else
			DecodedMessage = Command;
		end
	elseif (CommandType == "W") then
		if (Command == "S") then
			DecodedMessage = "Wand: "..Data;
		else
			DecodedMessage = Command;
		end
	elseif (CommandType == "H") then
		if (Command == "HT") then
			DecodedMessage = "Heal: Healthstone";
		elseif (SlaveGirl_CommDecode_Spell(Command)) then
			DecodedMessage = "Heal: "..SlaveGirl_CommDecode_Spell(Command);
			if (Data2 ~= "") then
				DecodedMessage = DecodedMessage.." ("..Data.."): "..Data2;
			elseif (Data ~= "") then
				DecodedMessage = DecodedMessage.." ("..Data..")";
			end
		else
			DecodedMessage = Command;
		end
	elseif (CommandType == "A") then
		if (SlaveGirl_CommDecode_Spell(Command)) then
			DecodedMessage = "Attack: "..SlaveGirl_CommDecode_Spell(Command);
			if (Data2 ~= "") then
				DecodedMessage = DecodedMessage.." ("..Data.."): "..Data2;
			elseif (Data ~= "") then
				DecodedMessage = DecodedMessage.." ("..Data..")";		
			end
		else
			DecodedMessage = Command;
		end
	elseif (CommandType == "B") then
		if (SlaveGirl_CommDecode_Spell(Command)) then
			DecodedMessage = "Buff: "..SlaveGirl_CommDecode_Spell(Command);
			if (Data2 ~= "") then
				DecodedMessage = DecodedMessage.." ("..Data.."): "..Data2;
			elseif (Data ~= "") then
				DecodedMessage = DecodedMessage.." ("..Data..")";		
			end
		else
			DecodedMessage = Command;
		end
	elseif (CommandType == "R") then
		DecodedMessage = "Resurrecting: "..Command;
	elseif (CommandType == "T") then
		DecodedMessage = "Target: "..Command;
		if (Command == "X") then
			DecodedMessage = "Target: "..Data.." [Unknown]";
		elseif (Command == "F") then
			DecodedMessage = "Target: "..Data.." [Friendly]";
		elseif (Command == "E") then
			DecodedMessage = "Target: "..Data.." [Enemy]";
		elseif (Command == "P") then
			DecodedMessage = "Target: "..Data.." [Party]";
		elseif (Command == "R") then
			DecodedMessage = "Target: "..Data.." [Raid]";
		elseif (Command == "S") then
			DecodedMessage = "Target: [Self]";
		elseif (Command == "M") then
			DecodedMessage = "Target: "..Data.." [Master]";
		else
			DecodedMessage = Command;
		end
		DecodedMessage = nil;
	elseif (CommandType == "F") then
		if (Command == "S") then
			if (Data) then
				DecodedMessage = "Follow: "..Data;
			else
				DecodedMessage = "Follow: [Start]";
			end
		elseif (Command == "X") then
			DecodedMessage = "Follow: [Stop]";
		else
			DecodedMessage = Command;
		end
	elseif (CommandType == "O") then
		if (Command == "T") then
			DecodedMessage = "Order: Accepting Trade";
		elseif (Command == "Q") then
			DecodedMessage = "Order: Accepting Quest ("..Data..")";
		else
			DecodedMessage = Command;
		end
	elseif (CommandType == "S") then
		if (SlaveGirl_CommDecode_Spell(Command)) then
			DecodedMessage = SlaveGirl_CommDecode_Spell(Command);
			if (Data2 ~= "") then
				DecodedMessage = DecodedMessage.." ("..Data.."): "..Data2;
			elseif (Data ~= "") then
				DecodedMessage = DecodedMessage.." ("..Data..")";		
			end
		else
			DecodedMessage = Command;
		end
	elseif (CommandType == "E") then
		if (Command == "V") then
			DecodedMessage = "Error: Can't cast -- Moving";
		elseif (Command == "C") then
			DecodedMessage = "Error: Can't cast -- Cooldown";
		elseif (Command == "L") then
			DecodedMessage = "Error: Can't cast -- No line of sight";
		elseif (Command == "B") then
			DecodedMessage = "Error: Can't cast -- Bad target";
		elseif (Command == "F") then
			DecodedMessage = "Error: Can't cast -- Target isn't in front";
		elseif (Command == "I") then
			DecodedMessage = "Error: Can't attack -- Invalid/Ignored target";
		elseif (Command == "N") then
			DecodedMessage = "Error: Can't attack -- Out of range/No Script";
		elseif (Command == "R") then
			DecodedMessage = "Error: Can't cast -- Out of range";
		elseif (Command == "X") then
			DecodedMessage = "Error: Can't cast -- In combat";
		elseif (Command == "M") then
			DecodedMessage = "Error: Can't cast -- Out of mana";
		elseif (Command == "S") then
			DecodedMessage = "Error: Can't cast -- Silenced/Stunned";
		else
			DecodedMessage = Command;
		end
	elseif (CommandType == "G") then
		if (Command == "M") then
			DecodedMessage = "COMMAND:MASTER";
		end
		if (Command == "S") then
			DecodedMessage = "COMMAND:SLAVE";
		end
	else
		DecodedMessage = sText;
	end
	
	return DecodedMessage;
end

function SlaveGirl_Command_Status()
	SlaveGirl_ChatPrint("Slave Girl Status Report:");
	if (SlaveGirl.Setting.Master) then
		SlaveGirl_ChatPrint("- Master: "..SlaveGirl.Setting.Master);
	else
		SlaveGirl_ChatPrint("- Master: [None]");
	end
	SlaveGirl_ChatPrint("- Comm Broadcasting: "..SlaveGirl_Logic(SlaveGirl.Setting.Broadcast));
end

function SlaveGirl_Logic(bValue)
	if (bValue) then
		if (bValue == false) then
			return "Off";
		else
			return "On";
		end
	else
		return "Off";
	end
end

function SlaveGirl_SaveSettings()
	SlaveGirl_DebugPrint("Saving settings");
	SlaveGirlOptions.Setting[SlaveGirl.Data.Me] = SlaveGirl.Setting;
	getglobal("SlaveGirl_MonitorButton"):SetChecked(SlaveGirl.Setting.Monitor);
	getglobal("SlaveGirl_BroadcastButton"):SetChecked(SlaveGirl.Setting.Broadcast);
	getglobal("SlaveGirl_StartFollowSoundButton"):SetChecked(SlaveGirl.Setting.StartFollowSound);
	getglobal("SlaveGirl_StopFollowSoundButton"):SetChecked(SlaveGirl.Setting.StopFollowSound);
	getglobal("SlaveGirl_LowHealthSoundButton"):SetChecked(SlaveGirl.Setting.LowHealthSound);
	getglobal("SlaveGirl_LowManaSoundButton"):SetChecked(SlaveGirl.Setting.LowManaSound);
	getglobal("SlaveGirl_AutoAcceptGroupInviteButton"):SetChecked(SlaveGirl.Setting.AutoAcceptGroupInvite);
	getglobal("SlaveGirl_AutoAcceptQuestButton"):SetChecked(SlaveGirl.Setting.AutoAcceptQuest);
	getglobal("SlaveGirl_AutoShareQuestButton"):SetChecked(SlaveGirl.Setting.AutoShareQuest);
	getglobal("SlaveGirl_AutoTurnInQuestButton"):SetChecked(SlaveGirl.Setting.AutoTurnInQuest);
	if (SlaveGirl.Setting.Master) then
		getglobal("SlaveGirl_MasterInfo"):SetText("Current master: |cFFEEEE00"..SlaveGirl.Setting.Master.."|r");
		getglobal("SlaveGirl_RemoveMasterButton"):Enable();
	else
		getglobal("SlaveGirl_MasterInfo"):SetText("Current master: [|cFFEE0000Nobody|r]");
		getglobal("SlaveGirl_RemoveMasterButton"):Disable();
	end
	getglobal("SlaveGirl_LowHealthSlider"):SetValue(SlaveGirl.Setting.LowHealthThreshold);
	if (SlaveGirl.Setting.LowHealthThreshold > 0) then
		getglobal("SlaveGirl_LowHealthValue"):SetText(SlaveGirl.Setting.LowHealthThreshold.."%");
	else
		getglobal("SlaveGirl_LowHealthValue"):SetText("Disabled");			
	end
	getglobal("SlaveGirl_LowManaSlider"):SetValue(SlaveGirl.Setting.LowManaThreshold);
	if (SlaveGirl.Setting.LowManaThreshold > 0) then
		getglobal("SlaveGirl_LowManaValue"):SetText(SlaveGirl.Setting.LowManaThreshold.."%");
	else
		getglobal("SlaveGirl_LowManaValue"):SetText("Disabled");			
	end
end

function SlaveGirl_ShareQuest(index)
    SelectQuestLogEntry(index)
    if (GetQuestLogPushable()) then
        QuestLogPushQuest(index)
    else
    		SlaveGirl_ErrorPrint("Unable to share "..GetQuestLink(index));
    end
end

-- Check the group for slaves
function SlaveGirl_CheckGroup(activelySearch)
	local raidmembers = GetNumGroupMembers();
	local partymembers = GetNumSubgroupMembers();
	if (raidmembers > 0 and not UnitExists("raid1")) then
		raidmembers = 0
	end
	SlaveGirl.Data.SlaveInGroup = nil;
	SlaveGirl.Data.MasterInGroup = nil;
	
	if (activelySearch and (raidmembers > 0 or partymembers > 0)) then
		SlaveGirl_SendComm("G/M", true);
		SlaveGirl_DebugPrint("Actively looking for slaves.");
	end
	if (raidmembers > 0) then
		for i = 1, raidmembers, 1 do
			local name = UnitName("raid"..i);
			if (SlaveGirl.Data.Slaves[name]) then
				SlaveGirl.Data.SlaveInGroup = true;
				SlaveGirl_DebugPrint("Slave is in group: Raid"..i);
			end
			if (SlaveGirl.Setting.Master == name) then
				SlaveGirl.Data.MasterInGroup = true;
				SlaveGirl_DebugPrint("Master is in group: Raid"..i);
			end
		end
	elseif (partymembers > 0) then
		for i = 1, partymembers, 1 do
			local name = UnitName("party"..i);
			if (SlaveGirl.Data.Slaves[name]) then
				SlaveGirl.Data.SlaveInGroup = true;
				SlaveGirl_DebugPrint("Slave is in group: Party"..i);
			end
			if (SlaveGirl.Setting.Master == name) then
				SlaveGirl.Data.MasterInGroup = true;
				SlaveGirl_DebugPrint("Master is in group: Party"..i);
			end
		end
	end
end

function SlaveGirl_ReportToMaster(master)
	if (master and SlaveGirl.Setting.Master == master) then
		SendAddonMessage(SlaveGirl.ModCode, "G/S", "WHISPER", SlaveGirl.Setting.Master);
		SlaveGirl_DebugPrint("Reporting to: "..master);
	end
end

-- Create Addon Menu options and interface
function SlaveGirl_RenderOptions()
	local ConfigurationPanel = CreateFrame("FRAME","SlaveGirl_MainFrame");
	ConfigurationPanel.name = "Slave Girl";
	InterfaceOptions_AddCategory(ConfigurationPanel);

	local IntroMessageHeader = ConfigurationPanel:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge");
	IntroMessageHeader:SetPoint("TOPLEFT", 10, -10);
	IntroMessageHeader:SetText("Slave Girl "..SlaveGirl.Version);

	local IntroMessageMaster = ConfigurationPanel:CreateFontString("SlaveGirl_MasterInfo", "ARTWORK", "GameFontNormal");
	IntroMessageMaster:SetPoint("TOPLEFT", 10, -35);
	IntroMessageMaster:SetText("Current Master: ");

	local IntroMessageFooter = ConfigurationPanel:CreateFontString(nil, "ARTWORK", "GameFontNormal");
	IntroMessageFooter:SetPoint("TOPLEFT", 10, -75);
	IntroMessageFooter:SetText("Click a player and click |cFFFFFFFFSet|r to set them as your master.");

	local SetMasterButton = CreateFrame("Button", "SlaveGirl_SetMasterButton", ConfigurationPanel, "OptionsButtonTemplate");
	SetMasterButton:SetPoint("TOPLEFT", 220, -30);
	SetMasterButton.tooltip = "Set this person as your master";
	SetMasterButton:SetScript("OnClick",SlaveGirl_Option_SetMaster);
	getglobal(SetMasterButton:GetName().."Text"):SetText("Set");

	local RemoveMasterButton = CreateFrame("Button", "SlaveGirl_RemoveMasterButton", ConfigurationPanel, "OptionsButtonTemplate");
	RemoveMasterButton:SetPoint("TOPLEFT", 310, -30);
	RemoveMasterButton.tooltip = "Remove this person as your master";
	RemoveMasterButton:SetScript("OnClick",SlaveGirl_Option_NoMaster);
	getglobal(RemoveMasterButton:GetName().."Text"):SetText("Remove");

	
	-- Communications

	local CommunicationPanel = CreateFrame("FRAME","SlaveGirl_CommunicationFrame");
	CommunicationPanel.name = "Communications";
	CommunicationPanel.parent = ConfigurationPanel.name;
	InterfaceOptions_AddCategory(CommunicationPanel);

	local MonitorButton = CreateFrame("CheckButton", "SlaveGirl_MonitorButton", CommunicationPanel, "ChatConfigCheckButtonTemplate");
	MonitorButton:SetPoint("TOPLEFT", 10, -15)
	MonitorButton.tooltip = "";
	getglobal(MonitorButton:GetName().."Text"):SetText(" Display slave communications to chat window");

	local BroadcastButton = CreateFrame("CheckButton", "SlaveGirl_BroadcastButton", CommunicationPanel, "ChatConfigCheckButtonTemplate");
	BroadcastButton:SetPoint("TOPLEFT", 10, -45)
	BroadcastButton.tooltip = "";
	getglobal(BroadcastButton:GetName().."Text"):SetText(" Broadcast error messages to master (when grouped)");

	-- Groups/Quests

	local QuestPanel = CreateFrame("FRAME","SlaveGirl_QuestFrame");
	QuestPanel.name = "Groups/Quests";
	QuestPanel.parent = ConfigurationPanel.name;
	InterfaceOptions_AddCategory(QuestPanel);

	local AutoAcceptGroupInviteButton = CreateFrame("CheckButton", "SlaveGirl_AutoAcceptGroupInviteButton", QuestPanel, "ChatConfigCheckButtonTemplate");
	AutoAcceptGroupInviteButton:SetPoint("TOPLEFT", 10, -15)
	AutoAcceptGroupInviteButton.tooltip = "";
	getglobal(AutoAcceptGroupInviteButton:GetName().."Text"):SetText(" Auto-accept master's group invite");

	local AutoAcceptQuestButton = CreateFrame("CheckButton", "SlaveGirl_AutoAcceptQuestButton", QuestPanel, "ChatConfigCheckButtonTemplate");
	AutoAcceptQuestButton:SetPoint("TOPLEFT", 10, -45)
	AutoAcceptQuestButton.tooltip = "";
	getglobal(AutoAcceptQuestButton:GetName().."Text"):SetText(" Auto-accept shared quests");

	local AutoShareQuestButton = CreateFrame("CheckButton", "SlaveGirl_AutoShareQuestButton", QuestPanel, "ChatConfigCheckButtonTemplate");
	AutoShareQuestButton:SetPoint("TOPLEFT", 10, -75)
	AutoShareQuestButton.tooltip = "";
	getglobal(AutoShareQuestButton:GetName().."Text"):SetText(" Auto-share quests (when grouped with a master or slave)");

	local AutoTurnInQuestButton = CreateFrame("CheckButton", "SlaveGirl_AutoTurnInQuestButton", QuestPanel, "ChatConfigCheckButtonTemplate");
	AutoTurnInQuestButton:SetPoint("TOPLEFT", 10, -105)
	AutoTurnInQuestButton.tooltip = "";
	getglobal(AutoTurnInQuestButton:GetName().."Text"):SetText(" Auto-start and complete quests (that don't have rewards)");

	-- Sounds

	local SoundPanel = CreateFrame("FRAME","SlaveGirl_SoundFrame");
	SoundPanel.name = "Sounds";
	SoundPanel.parent = ConfigurationPanel.name;
	InterfaceOptions_AddCategory(SoundPanel);

	local StartFollowSoundButton = CreateFrame("CheckButton", "SlaveGirl_StartFollowSoundButton", SoundPanel, "ChatConfigCheckButtonTemplate");
	StartFollowSoundButton:SetPoint("TOPLEFT", 10, -15)
	StartFollowSoundButton.tooltip = "";
	getglobal(StartFollowSoundButton:GetName().."Text"):SetText(" Start Following");

	local StartFollowSoundTestButton = CreateFrame("Button", "SlaveGirl_StartFollowSoundTestButton", SoundPanel, "OptionsButtonTemplate");
	StartFollowSoundTestButton:SetPoint("TOPLEFT", 300, -15);
	StartFollowSoundTestButton.tooltip = "Play the sound of when your character is following another";
	StartFollowSoundTestButton:SetScript("OnClick",SlaveGirl_Option_StartFollowTest);
	getglobal(StartFollowSoundTestButton:GetName().."Text"):SetText("Test");

	local StopFollowSoundButton = CreateFrame("CheckButton", "SlaveGirl_StopFollowSoundButton", SoundPanel, "ChatConfigCheckButtonTemplate");
	StopFollowSoundButton:SetPoint("TOPLEFT", 10, -45)
	StopFollowSoundButton.tooltip = "";
	getglobal(StopFollowSoundButton:GetName().."Text"):SetText(" Stop Following");

	local StopFollowSoundTestButton = CreateFrame("Button", "SlaveGirl_StopFollowSoundTestButton", SoundPanel, "OptionsButtonTemplate");
	StopFollowSoundTestButton:SetPoint("TOPLEFT", 300, -45);
	StopFollowSoundTestButton.tooltip = "Play the sound of when your character stops following another";
	StopFollowSoundTestButton:SetScript("OnClick",SlaveGirl_Option_StopFollowTest);
	getglobal(StopFollowSoundTestButton:GetName().."Text"):SetText("Test");

	local LowHealthSoundButton = CreateFrame("CheckButton", "SlaveGirl_LowHealthSoundButton", SoundPanel, "ChatConfigCheckButtonTemplate");
	LowHealthSoundButton:SetPoint("TOPLEFT", 10, -75)
	LowHealthSoundButton.tooltip = "";
	getglobal(LowHealthSoundButton:GetName().."Text"):SetText(" Low Health");

	local LowHealthSoundTestButton = CreateFrame("Button", "SlaveGirl_LowHealthSoundTestButton", SoundPanel, "OptionsButtonTemplate");
	LowHealthSoundTestButton:SetPoint("TOPLEFT", 300, -75);
	LowHealthSoundTestButton.tooltip = "Play the sound of when your character is following another";
	LowHealthSoundTestButton:SetScript("OnClick",SlaveGirl_Option_LowHealthTest);
	getglobal(LowHealthSoundTestButton:GetName().."Text"):SetText("Test");

	local LowHealthSlider = CreateFrame("Slider", "SlaveGirl_LowHealthSlider", SoundPanel, "OptionsSliderTemplate");
	LowHealthSlider:SetPoint("TOPLEFT", 45, -115);
	LowHealthSlider.tooltip = "Percentage of HP to sound alert";
	LowHealthSlider:SetScript("OnValueChanged",SlaveGirl_Option_SetLowHealth);
	getglobal(SlaveGirl_LowHealthSlider:GetName().."Text"):SetText("Health %");
	getglobal(SlaveGirl_LowHealthSlider:GetName().."High"):SetText("Max");
	getglobal(SlaveGirl_LowHealthSlider:GetName().."Low"):SetText("Min");
	LowHealthSlider:SetMinMaxValues(0,100);
	LowHealthSlider:SetValueStep(1);
	LowHealthSlider:SetValue(SlaveGirl.Setting.LowHealthThreshold);

	local LowHealthValue = SoundPanel:CreateFontString("SlaveGirl_LowHealthValue", "ARTWORK", "GameFontNormal");
	LowHealthValue:SetPoint("TOPLEFT", 200, -115);
	LowHealthValue:SetText(SlaveGirl.Setting.LowHealthThreshold.."%");

	local LowManaSoundButton = CreateFrame("CheckButton", "SlaveGirl_LowManaSoundButton", SoundPanel, "ChatConfigCheckButtonTemplate");
	LowManaSoundButton:SetPoint("TOPLEFT", 10, -145)
	LowManaSoundButton.tooltip = "";
	getglobal(LowManaSoundButton:GetName().."Text"):SetText(" Low Mana");

	local LowManaSoundTestButton = CreateFrame("Button", "SlaveGirl_LowManaSoundTestButton", SoundPanel, "OptionsButtonTemplate");
	LowManaSoundTestButton:SetPoint("TOPLEFT", 300, -145);
	LowManaSoundTestButton.tooltip = "Play the sound of when your character is following another";
	LowManaSoundTestButton:SetScript("OnClick",SlaveGirl_Option_LowManaTest);
	getglobal(LowManaSoundTestButton:GetName().."Text"):SetText("Test");

	local LowManaSlider = CreateFrame("Slider", "SlaveGirl_LowManaSlider", SoundPanel, "OptionsSliderTemplate");
	LowManaSlider:SetPoint("TOPLEFT", 45, -185);
	LowManaSlider.tooltip = "Percentage of Mana to sound alert";
	LowManaSlider:SetScript("OnValueChanged",SlaveGirl_Option_SetLowMana);
	getglobal(SlaveGirl_LowManaSlider:GetName().."Text"):SetText("Mana %");
	getglobal(SlaveGirl_LowManaSlider:GetName().."High"):SetText("Max");
	getglobal(SlaveGirl_LowManaSlider:GetName().."Low"):SetText("Min");
	LowManaSlider:SetMinMaxValues(0,100);
	LowManaSlider:SetValueStep(1);
	LowManaSlider:SetValue(SlaveGirl.Data.LowManaThreshold);

	local LowManaValue = SoundPanel:CreateFontString("SlaveGirl_LowManaValue", "ARTWORK", "GameFontNormal");
	LowManaValue:SetPoint("TOPLEFT", 200, -185);
	LowManaValue:SetText(SlaveGirl.Data.LowManaThreshold.."%");
	
	ConfigurationPanel.okay = 
		function (self)
			SlaveGirl.Setting.Monitor = MonitorButton:GetChecked();
			SlaveGirl.Setting.Broadcast = BroadcastButton:GetChecked();
			SlaveGirl.Setting.StartFollowSound = StartFollowSoundButton:GetChecked();
			SlaveGirl.Setting.StopFollowSound = StopFollowSoundButton:GetChecked();
			SlaveGirl.Setting.LowHealthSound = LowHealthSoundButton:GetChecked();
			SlaveGirl.Setting.LowManaSound = LowManaSoundButton:GetChecked();
			SlaveGirl.Setting.AutoAcceptGroupInvite = AutoAcceptGroupInviteButton:GetChecked();
			SlaveGirl.Setting.AutoAcceptQuest = AutoAcceptQuestButton:GetChecked();
			SlaveGirl.Setting.AutoShareQuest = AutoShareQuestButton:GetChecked();
			SlaveGirl.Setting.AutoTurnInQuest = AutoTurnInQuestButton:GetChecked();
			SlaveGirl.Setting.LowHealthThreshold = getglobal("SlaveGirl_LowHealthSlider"):GetValue();
			SlaveGirl.Setting.LowManaThreshold = getglobal("SlaveGirl_LowManaSlider"):GetValue();
			SlaveGirl_SaveSettings();
		end
	ConfigurationPanel.cancel = 
		function (self)
			SlaveGirl_ResetDefaults();
			SlaveGirl_SaveSettings();
		end
	ConfigurationPanel.default = 
		function (self)
			SlaveGirl_ResetDefaults();
			SlaveGirl_SaveSettings();
		end
	SoundPanel.default = 
		function (self)
			SlaveGirl_ResetDefaults();
			SlaveGirl_SaveSettings();
		end
	QuestPanel.default = 
		function (self)
			SlaveGirl_ResetDefaults();
			SlaveGirl_SaveSettings();
		end
	CommunicationPanel.default = 
		function (self)
			SlaveGirl_ResetDefaults();
			SlaveGirl_SaveSettings();
		end
end

function SlaveGirl_Option_StartFollowTest()
	SlaveGirl_PlaySound("StartFollow");
end

function SlaveGirl_Option_StopFollowTest()
	SlaveGirl_PlaySound("StopFollow");
end

function SlaveGirl_Option_LowHealthTest()
	SlaveGirl_PlaySound("LowHealth");
end

function SlaveGirl_Option_LowManaTest()
	SlaveGirl_PlaySound("LowMana");
end

function SlaveGirl_Option_SetMaster()
	if (UnitName("target")) then
		SlaveGirl_Command_Master(nil);
	end
end

function SlaveGirl_Option_NoMaster()
	SlaveGirl_Command_Master("c");
end

function SlaveGirl_Option_SetLowHealth()
	SlaveGirl.Data.LowHealthThreshold = getglobal("SlaveGirl_LowHealthSlider"):GetValue();
	if (getglobal("SlaveGirl_LowHealthValue")) then
		if (SlaveGirl.Data.LowHealthThreshold > 0) then
			getglobal("SlaveGirl_LowHealthValue"):SetText(SlaveGirl.Data.LowHealthThreshold.."%");
		else
			getglobal("SlaveGirl_LowHealthValue"):SetText("Disabled");			
		end
	end
end

function SlaveGirl_Option_SetLowMana()
	SlaveGirl.Data.LowManaThreshold = getglobal("SlaveGirl_LowManaSlider"):GetValue();
	if (getglobal("SlaveGirl_LowManaValue")) then
		if (SlaveGirl.Data.LowManaThreshold > 0) then
			getglobal("SlaveGirl_LowManaValue"):SetText(SlaveGirl.Data.LowManaThreshold.."%");
		else
			getglobal("SlaveGirl_LowManaValue"):SetText("Disabled");			
		end
	end
end
